-module(rumRotatorExm).

%% Create a log file
-callback createLogFile(Name :: list(), Buffer :: {integer(), integer()} | any()) ->
   {ok, {file:io_device(), integer(), file:date_time(), integer()}} |
   {error, any()}.

%% Open a log file
-callback openLogFile(Name :: list(), Buffer :: {integer(), integer()} | any()) ->
   {ok, {file:io_device(), integer(), file:date_time(), integer()}} |
   {error, any()}.

%% Ensure reference to current target, could be rotated
-callback ensureLogFile(Name :: list(), FD :: file:io_device(), Inode :: integer(), CTime :: file:date_time(), Buffer :: {integer(), integer()} | any()) ->
   {ok, {file:io_device(), integer(), file:date_time(), integer()}} |
   {error, any()}.

%% Rotate the log file
-callback rotateLogFile(Name :: list(), Count :: integer()) ->
   ok.
